## visp 3.0.0

=== CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. Detect third party libraries (X11, GTK, ...)
#
# Authors:
# Fabien Spindler
#
#############################################################################

# Need to be befor project(VISP) to work
if(WIN32)
  set(CMAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/install" CACHE PATH "Installation Directory")
endif()

project(VISP C CXX)

cmake_minimum_required(VERSION 2.8.3)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(cmake/VISPUtils.cmake)

vp_clear_vars(VISPModules_TARGETS)

#-----------------------------------------------------------------------------
# VISP version number.  An even minor number corresponds to releases.
set(VISP_VERSION_MAJOR "3")
set(VISP_VERSION_MINOR "0")
set(VISP_VERSION_PATCH "0")
set(VISP_VERSION "${VISP_VERSION_MAJOR}.${VISP_VERSION_MINOR}.${VISP_VERSION_PATCH}")
# Package revision number
set(VISP_REVISION "1")

find_file(GNU_INSTALL_DIRS_FROM_CMAKE NAMES GNUInstallDirs.cmake PATHS ${CMAKE_ROOT}/Modules)
mark_as_advanced(GNU_INSTALL_DIRS_FROM_CMAKE)
if(GNU_INSTALL_DIRS_FROM_CMAKE)
  include(${CMAKE_ROOT}/Modules/GNUInstallDirs.cmake)
else()
  include(cmake/GNUInstallDirs.cmake)
endif()

# the include directory we depend on
set(VISP_INCLUDE_DIR ${VISP_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR})
set(VISP_DOC_DIR "${VISP_BINARY_DIR}/doc")

# The location in which to install VISP libraries.
set(LIBRARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
# The location in which to install some VISP binaries.
set(BINARY_OUTPUT_PATH ${VISP_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})

include_directories(${VISP_BINARY_DIR}/include)

if(WIN32)
  # Postfix of .lib and .dll
  set(VISP_DEBUG_POSTFIX "d")
  set(VISP_DLLVERSION "${VISP_VERSION_MAJOR}${VISP_VERSION_MINOR}${VISP_VERSION_PATCH}")
else()
  set(VISP_DEBUG_POSTFIX "")
  set(VISP_DLLVERSION "")
endif()

# ----------------------------------------------------------------------------
# Handle always full RPATH
# http://www.cmake.org/Wiki/CMake_RPATH_handling
# ----------------------------------------------------------------------------

# avoid CMP0042 warning
if(APPLE)
  set(CMAKE_MACOSX_RPATH ON)
endif()

# use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# the RPATH to be used when installing, but only if it's not a system directory
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}" isSystemDir)
if("${isSystemDir}" STREQUAL "-1")
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endif("${isSystemDir}" STREQUAL "-1")

# ----------------------------------------------------------------------------
#  Path for additional contrib modules
# ----------------------------------------------------------------------------
set(VISP_CONTRIB_MODULES_PATH "" CACHE PATH "Where to look for additional contrib ViSP modules")

# Get the OS
set(OS ${CMAKE_SYSTEM_NAME})

set(OGRE_HOME $ENV{OGRE_HOME})
if(OGRE_HOME)
  # replace \ with / especially for windows
  STRING(REGEX REPLACE "\\\\" "/" OGRE_HOME ${OGRE_HOME}) 
endif()

# add the path to detect Ogre3D
if(WIN32)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/CMake")
endif(WIN32)
 
if(UNIX)
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/cmake")
  list(APPEND CMAKE_MODULE_PATH "${OGRE_HOME}/CMake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/local/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/lib64/OGRE/cmake")
  list(APPEND CMAKE_MODULE_PATH "/usr/share/OGRE/cmake/modules")
endif(UNIX)

#--------------------------------------------------------------------
# Option management
#--------------------------------------------------------------------

# Choose static or shared libraries.
VP_OPTION(BUILD_SHARED_LIBS  "" "" "Build ViSP shared libraries (.dll/.so) instead of static ones (.lib/.a)" "" ON)
# Build examples as an option.
VP_OPTION(BUILD_EXAMPLES  "" "" "Build ViSP examples" "" ON)
# Build examples as an option.
VP_OPTION(BUILD_TESTS  "" "" "Build ViSP tests" "" ON)
VP_OPTION(BUILD_COVERAGE "" "" "Enables test coverage" "" OFF IF (BUILD_TESTS AND CMAKE_COMPILER_IS_GNUCXX AND NOT BUILD_SHARED_LIBS AND CMAKE_BUILD_TYPE MATCHES "Debug"))

# Build demos as an option.
VP_OPTION(BUILD_DEMOS  "" "" "Build ViSP demos" "" ON)
# Build demos as an option.
VP_OPTION(BUILD_TUTORIALS  "" "" "Build ViSP tutorials" "" ON)
# Build deprecated functions as an option.
VP_OPTION(BUILD_DEPRECATED_FUNCTIONS  "" "" "Build deprecated functionalities" "" ON)
# Debug and trace cflags
VP_OPTION(ACTIVATE_DEBUG_TRACE  "" "" "Enable debug and trace printings" "" ON)

VP_OPTION(BUILD_WITH_STATIC_CRT  "" "" "Enables use of staticaly linked CRT for staticaly linked ViSP" "" ON IF MSVC)

# Note that it is better to set MOMENTS_COMBINE_MATRICES to OFF
VP_OPTION(MOMENTS_COMBINE_MATRICES  "" "" "Use linear combination of matrices instead of linear combination of moments to compute interaction matrices." "MOMENTS_COMBINE_MATRICES" OFF)
VP_OPTION(ENABLE_TEST_WITHOUT_DISPLAY  "" "" "Don't use display features when testing" "ENABLE_TEST_WITHOUT_DISPLAY" ON)

if(ENABLE_TEST_WITHOUT_DISPLAY)
  set(OPTION_TO_DESACTIVE_DISPLAY "-d")
endif()

# Check for Inria's robot drivers
VP_CHECK_PACKAGE(RAW1394)
VP_CHECK_PACKAGE(RT)
VP_CHECK_PACKAGE(CALINUX)
VP_CHECK_PACKAGE(IRISA)
# Try to determine if Inria's NAS server hosting /udd/ is available
VP_CHECK_PACKAGE(NAS)
# check for linux/parport.h
VP_CHECK_PACKAGE(PARPORT)
# Find IsNaN
VP_CHECK_PACKAGE(IsNaN)
# Find IsInf
VP_CHECK_PACKAGE(IsInf)
# Find Round
VP_CHECK_PACKAGE(Round)
# OpenGL
VP_CHECK_PACKAGE(OpenGL)
# for pioneer
VP_CHECK_PACKAGE(RT)
VP_CHECK_PACKAGE(DL)

VP_OPTION(USE_AFMA4    "" "" "Include Afma4 robot support"      "" ON IF (RAW1394_FOUND AND RT_FOUND AND CALINUX_FOUND AND IRISA_FOUND))
VP_OPTION(USE_AFMA6    "" "" "Include Afma6 robot support"      "" ON IF (RAW1394_FOUND AND RT_FOUND AND CALINUX_FOUND AND IRISA_FOUND))
VP_OPTION(USE_VIPER650 "" "" "Include Viper s650 robot support" "" ON IF (RAW1394_FOUND AND RT_FOUND AND CALINUX_FOUND AND IRISA_FOUND))
VP_OPTION(USE_VIPER850 "" "" "Include Viper s850 robot support" "" ON IF (RAW1394_FOUND AND RT_FOUND AND CALINUX_FOUND AND IRISA_FOUND))
VP_OPTION(USE_DC1394      DC1394      "" "Include dc1394 support"          "" ON IF UNIX)
VP_OPTION(USE_V4L2        V4L2        "" "Include v4l2 support"            "" ON IF UNIX)
VP_OPTION(USE_BICLOPS     BICLOPS     "" "Include biclops support"         "" ON IF UNIX)
VP_OPTION(USE_PTU46       PTU46       "" "Include ptu-46 support"          "" ON IF UNIX)
VP_OPTION(USE_CMU1394     CMU1394     "" "Include cmu1494 support"         "" ON IF WIN32)
VP_OPTION(USE_GDI         GDI         "" "Include gdi support"             "" ON IF WIN32)
VP_OPTION(USE_DIRECT3D    DIRECT3D    "" "Include d3d support"             "" ON IF WIN32)
VP_OPTION(USE_DIRECTSHOW  DIRECTSHOW  "" "Include dshow support"           "" ON IF WIN32)
VP_OPTION(USE_OPENMP      OpenMP      "" "Include openmp support"          "" ON)
VP_OPTION(USE_CPP11       CPP11       "" "Include c++11 support"           "" OFF)
# Since the FindLAPACK.cmake provided with CMake is for Fortran language,
# in CMakeModules we have added FindLAPACK_C.cmake for C language
VP_OPTION(USE_LAPACK      LAPACK_C    "" "Include lapack support"          "" ON)
VP_OPTION(USE_GSL         GSL         "" "Include gsl support"             "" ON)
VP_OPTION(USE_COIN3D      "Coin3D;MyCoin3D" "" "Include coin3d support"          "" ON IF OPENGL_FOUND)
VP_OPTION(USE_YARP        YARP        QUIET "Include yarp support"         "YARP_DIR" ON)
VP_OPTION(USE_OGRE        OGRE        QUIET "Include Ogre support"         "OGRE_DIR" ON)
VP_OPTION(USE_OIS         OIS         QUIET "Include Ogre/ois support"     "OIS_DIR"  ON IF USE_OGRE)
VP_OPTION(USE_LIBFREENECT LIBFREENECT ""    "Include libfreenect support"  "" ON)
VP_OPTION(USE_LIBUSB_1    LIBUSB_1    ""    "Include libusb-1 support"     "" ON)
VP_OPTION(USE_SOWIN       SOWIN       ""    "Include Coin/SoWin support"   "" OFF IF (WIN32 AND USE_COIN3D))
VP_OPTION(USE_SOQT        SOQT        ""    "Include Coin/SoQt support"    "" OFF IF USE_COIN3D)
VP_OPTION(USE_QT          Qt          ""    "Include Coin/SoQt/Qt support" "" ON  IF USE_SOQT)
VP_OPTION(USE_SOXT        SOXT        ""    "Include Coin/SoXt support"    "" OFF IF USE_COIN3D)
VP_OPTION(USE_PTHREAD     PTHREAD     ""    "Include pthread support"      "" ON)
VP_OPTION(USE_XML2        XML2        ""    "Include xml support"          "" ON)
VP_OPTION(USE_OPENCV      OpenCV      QUIET "Include OpenCV support" "OpenCV_DIR;OpenCV_FOUND;OPENCV_FOUND" ON)
VP_OPTION(USE_ZLIB        "ZLIB;MyZLIB" ""  "Include zlib support"         "" ON)
VP_OPTION(USE_X11         X11         ""    "Include X11 support"          "" ON)
# The native FindGTK2.cmake doesn't consider libgobject-2.0 that is 
# requested by ViSP. That's why we use our FindMyGTK2.cmake 
VP_OPTION(USE_GTK2        MyGTK2       ""    "Include gtk2 support"         "" OFF)
VP_OPTION(USE_JPEG       "JPEG;MyJPEG" ""    "Include jpeg support"         "" ON)
VP_OPTION(USE_PNG        "PNG;MyPNG"   ""    "Include png support"          "" ON)
VP_OPTION(USE_FFMPEG      FFMPEG       ""    "Include ffmpeg support"       "" OFF)
# To control Pioneer mobile robots, under UNIX we need Aria, pthread, rt and dl 3rd party libraries
VP_OPTION(USE_ARIA        ARIA         ""    "Include aria support"         "" ON)
#VP_OPTION(USE_RT          RT           ""    "Include rt support"           "" ON)
#VP_OPTION(USE_DL          DL           ""    "Include dl support"           "" ON)
# bar codes
VP_OPTION(USE_ZBAR        ZBAR         ""    "Include zbar support"         "" ON)
VP_OPTION(USE_DMTX        DMTX         ""    "Include dmtx support"         "" ON)

#----------------------------------------------------------------------
# For Dart server and tests
# We use CDash set through CTestConfig.cmake file
# Dashboards are sent to http://cdash.irisa.fr/CDash/index.php?project=ViSP
#----------------------------------------------------------------------
if(BUILD_TESTS)
  enable_testing()
  mark_as_advanced(DART_ROOT)
  mark_as_advanced(BUILD_TESTING)
endif()

#----------------------------------------------------------------------
# Try to find doxygen for documentation generation
# Use "make visp_doc" target to generate the documentation

=== demo/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Nicolas Melchior
#
#############################################################################

project(ViSP-demo)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(wireframe-simulator REQUIRED_DEPS visp_core visp_robot visp_vs visp_io visp_gui)

=== example/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(ViSP-examples)

cmake_minimum_required(VERSION 2.6)

find_package(VISP)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(calibration              REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(coin-simulator           REQUIRED_DEPS visp_core visp_robot visp_vs visp_ar visp_io)
visp_add_subdirectory(device/display           REQUIRED_DEPS visp_core visp_gui visp_io)
visp_add_subdirectory(device/framegrabber      REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(device/kinect            REQUIRED_DEPS visp_core visp_sensor visp_gui)
visp_add_subdirectory(device/laserscanner      REQUIRED_DEPS visp_core visp_sensor visp_io)
visp_add_subdirectory(device/light             REQUIRED_DEPS visp_core visp_robot visp_io)
visp_add_subdirectory(direct-visual-servoing   REQUIRED_DEPS visp_core visp_robot visp_visual_features visp_io visp_gui)
visp_add_subdirectory(homography               REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(image                    REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(key-point                REQUIRED_DEPS visp_core visp_vision visp_sensor visp_io visp_gui)
visp_add_subdirectory(manual                   REQUIRED_DEPS visp_core visp_sensor visp_vs visp_robot visp_ar visp_vision visp_io visp_gui)
visp_add_subdirectory(math                     REQUIRED_DEPS visp_core visp_vision visp_io)
visp_add_subdirectory(moments/image            REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/points           REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(moments/polygon          REQUIRED_DEPS visp_core visp_vs visp_robot visp_gui)
visp_add_subdirectory(ogre-simulator           REQUIRED_DEPS visp_core visp_vision visp_ar visp_blob visp_io visp_gui)
visp_add_subdirectory(parse-argv               REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(pose-estimation          REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(robot-simulator/afma6    REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/camera   REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(robot-simulator/viper850 REQUIRED_DEPS visp_core visp_vs visp_robot visp_io visp_gui)
visp_add_subdirectory(servo-afma4              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-afma6              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-biclops            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-pioneer            REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-ptu46              REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_gui)
visp_add_subdirectory(servo-viper650           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(servo-viper850           REQUIRED_DEPS visp_core visp_blob visp_vs visp_robot visp_sensor visp_vision visp_gui)
visp_add_subdirectory(tools                    REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(tracking                 REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(video                    REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(wireframe-simulator      REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)

=== modules/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file.
#
# Authors:
# Fabien Spindler
#
#############################################################################

if(NOT VISP_MODULES_PATH)
  set(VISP_MODULES_PATH "${CMAKE_CURRENT_SOURCE_DIR}")
endif()

# extra modules are outside ViSP. Useful for contrib or specific additional modules
vp_glob_modules(${VISP_MODULES_PATH} EXTRA ${VISP_CONTRIB_MODULES_PATH})

=== tutorial/CMakeLists.txt ===
project(ViSP-tutorial)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED)

if(MSVC)
  if(NOT VISP_SHARED)
    foreach(flag_var
            CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
            CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO
            CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
            CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
      if(${flag_var} MATCHES "/MD")
        string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
      endif()
      if(${flag_var} MATCHES "/MDd")
        string(REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}")
      endif()
    endforeach(flag_var)

    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /NODEFAULTLIB:atlthunk.lib /NODEFAULTLIB:msvcrt.lib /NODEFAULTLIB:msvcrtd.lib")
    set(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:libcmt.lib")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /NODEFAULTLIB:libcmtd.lib")
  endif()
endif()

visp_add_subdirectory(bridge/opencv                 REQUIRED_DEPS visp_core visp_io)
visp_add_subdirectory(computer-vision               REQUIRED_DEPS visp_core visp_blob visp_vision visp_io visp_gui)
visp_add_subdirectory(grabber                       REQUIRED_DEPS visp_core visp_sensor visp_io visp_gui)
visp_add_subdirectory(detection/barcode             REQUIRED_DEPS visp_core visp_detection visp_io visp_gui)
visp_add_subdirectory(detection/face                REQUIRED_DEPS visp_core visp_detection visp_io visp_gui)
visp_add_subdirectory(detection/matching            REQUIRED_DEPS visp_core visp_vision visp_io visp_gui)
visp_add_subdirectory(detection/object              REQUIRED_DEPS visp_core visp_vision visp_mbt visp_io visp_gui)
visp_add_subdirectory(image                         REQUIRED_DEPS visp_core visp_io visp_gui)
visp_add_subdirectory(robot/pioneer                 REQUIRED_DEPS visp_core visp_robot visp_vs visp_gui)
visp_add_subdirectory(simulator/image               REQUIRED_DEPS visp_core visp_robot visp_io visp_gui)
visp_add_subdirectory(trace                         REQUIRED_DEPS visp_core)
visp_add_subdirectory(tracking/blob                 REQUIRED_DEPS visp_core visp_blob visp_io visp_gui)
visp_add_subdirectory(tracking/keypoint             REQUIRED_DEPS visp_core visp_vision visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/generic  REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/edges    REQUIRED_DEPS visp_core visp_mbt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/hybrid   REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/model-based/keypoint REQUIRED_DEPS visp_core visp_mbt visp_klt visp_io visp_gui)
visp_add_subdirectory(tracking/template-tracker     REQUIRED_DEPS visp_core visp_tt visp_io visp_gui)
visp_add_subdirectory(tracking/moving-edges         REQUIRED_DEPS visp_core visp_me visp_io visp_gui)
visp_add_subdirectory(visual-servo/ibvs             REQUIRED_DEPS visp_core visp_robot visp_vs visp_blob visp_vision visp_io visp_gui)

=== demo/wireframe-simulator/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(demo-wireframe-simulator)

cmake_minimum_required(VERSION 2.8)

find_package(VISP REQUIRED visp_core visp_robot visp_vs visp_io visp_gui)

# SOURCE variable corresponds to the list of all the sources to build binaries.
# The generate binary comes by removing the .cpp extension to
# the source name.
#
# If you want to add/remove a source, modify here
set(demo_cpp
  servoSimu4Points.cpp
  servoSimuCylinder.cpp
  servoSimuSphere.cpp
)

foreach(cpp ${demo_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "demos")
  endif()
endforeach()

# Add test
# To run some of these tests don't forget to set VISP_INPUT_IMAGE_PATH
# environment variable to the ViSP test sequences location.
# To get these sequence download ViSP-images.tar.gz from
# http://www.irisa.fr/lagadic/visp/visp.html
add_test(servoSimu4Points servoSimu4Points -d)
add_test(servoSimuCylinder servoSimuCylinder -d)
add_test(servoSimuSphere servoSimuSphere -d)

=== example/calibration/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-calibration)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_vision visp_gui visp_io)

set(example_cpp
  camera_calibration.cpp
  calibrateTsai.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()
endforeach()

# Add test
# To run these tests automaticaly using the crontab under Unix or the task
# manager under windows, we have to add the -d option to turn off the display
# of acquired images
add_test(calibrateTsai calibrateTsai)

# copy the data
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/default-chessboard.cfg" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/default-circles.cfg" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-01.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-02.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-03.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-04.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/chessboard-05.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-01.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-02.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-03.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-04.png" )
list(APPEND data2copy "${CMAKE_CURRENT_SOURCE_DIR}/circles-05.png" )

# Copy the data files to the same location than the target
foreach(data ${data2copy})
  visp_copy_data(camera_calibration.cpp ${data})
endforeach()

=== example/coin-simulator/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-coin-simulator)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_robot visp_vs visp_ar visp_io)

set(example_cpp
  simulateFourPoints2DCartesianCamVelocity.cpp
  simulateFourPoints2DPolarCamVelocity.cpp
  simulateCircle2DCamVelocity.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()

  # Add test
  get_filename_component(target ${cpp} NAME_WE)
  add_test(${target} ${target} ${OPTION_TO_DESACTIVE_DISPLAY})
endforeach()

=== example/direct-visual-servoing/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-direct-vvs)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_robot visp_visual_features visp_io visp_gui)

set(example_cpp
  photometricVisualServoing.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()
endforeach()

add_test(photometricVisualServoing photometricVisualServoing -c -n 20 ${OPTION_TO_DESACTIVE_DISPLAY})

=== example/homography/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-homography)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_vision visp_io)

set(example_cpp
  homographyHartleyDLT2DObject.cpp
  homographyHLM2DObject.cpp
  homographyHLM3DObject.cpp
  homographyRansac2DObject.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()

  # Add test
  get_filename_component(target ${cpp} NAME_WE)
  add_test(${target} ${target})
endforeach()

=== example/image/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-image)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_io)

set(example_cpp
  imageDiskRW.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()

  # Add test
  get_filename_component(target ${cpp} NAME_WE)
  add_test(${target} ${target})
endforeach()

=== example/key-point/CMakeLists.txt ===
#############################################################################
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2015 by Inria. All rights reserved.
#
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact Inria about acquiring a ViSP Professional
# Edition License.
#
# See http://visp.inria.fr for more information.
#
# This software was developed at:
# Inria Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
#
# If you have questions regarding the use of this file, please contact
# Inria at visp@inria.fr
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# ViSP overall configuration file. 
#
# Authors:
# Fabien Spindler
#
#############################################################################

project(example-keypoint)

cmake_minimum_required(VERSION 2.6)

find_package(VISP REQUIRED visp_core visp_vision visp_sensor visp_io visp_gui)

set(example_cpp
  keyPointSurf.cpp
  planarObjectDetector.cpp
  fernClassifier.cpp
)

foreach(cpp ${example_cpp})
  visp_add_target(${cpp})
  if(COMMAND visp_add_dependency)
    visp_add_dependency(${cpp} "examples")
  endif()
endforeach()

# Add test
#ADD_TEST(planarObjectDetector planarObjectDetector -l -c ${OPTION_TO_DESACTIVE_DISPLAY})

=== debian/changelog ===
visp (3.0.0-4) unstable; urgency=medium

  * Remove libusb-1.0-0-dev explicit dependency that will come from
    libfreenect-dev implicit dep.
  * Remove libfreenect also for kfreebsd-amd64 and kfreebsd-i386
    (BD-Uninstallable)
  * Since Ogre removal, remove dh_override_install (Closes: #813564)
  * Remove doxygen-latex useless dependency

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Wed, 03 Feb 2016 11:56:55 +0100

visp (3.0.0-3) unstable; urgency=medium

  * Remove Ogre and Ois dependencies to prevent ViSP from autoremoval
    from testing on 2016-02-19 due to a transitively dependency on blender
    affected by RC bug(s) 804678 and 810065.

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 01 Feb 2016 18:00:21 +0100

visp (3.0.0-2) unstable; urgency=medium

  * Fix missing Breaks/Replaces relation to fix upgrade from
    testing (Closes: #810354)
  * Switch to libusb-1.0 (Closes: #810464)
  * Introduce patches to fix issues

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Sat, 09 Jan 2016 18:23:36 +0100

visp (3.0.0-1) unstable; urgency=medium

  * Update watch file since website migration
  * Imported Upstream version 3.0.0
  * Update debian material for ViSP 3.0.0

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Thu, 31 Dec 2015 18:53:34 +0100

visp (2.10.0+dfsg-2) unstable; urgency=medium

  * Make testing arch dependent (Closes: #806876)
  * Update build dependencies for GSL 2, change libgsl0-dev to libgsl-dev
    (Closes: #807228)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Mon, 07 Dec 2015 21:54:33 +0100

visp (2.10.0+dfsg-1) unstable; urgency=medium

  * Replace lena non dfsg images by monkey images (Closes: #794861)
  * Bashism in /bin/sh script already fixed since 2.10.0-1 (Closes: #772331)

 -- Fabien Spindler <Fabien.Spindler@inria.fr>  Fri, 18 Sep 2015 10:43:50 +0200

=== debian/control ===
Source: visp
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>, Fabien Spindler <Fabien.Spindler@inria.fr>
Section: libs
Priority: extra
Build-Depends: debhelper (>= 9),
	cmake,
	doxygen,
	libopencv-dev,
	liblapack-dev,
	libgsl-dev,
	libcoin80-dev,
	libsoqt4-dev,
	libdc1394-22-dev [linux-any],
	libv4l-dev [linux-any],
	libfreenect-dev [!hurd-any !kfreebsd-any],
	libxml2-dev,
	libjpeg-dev,
	libpng-dev,
	libx11-dev,
	libzbar-dev,
	libdmtx-dev,
	visp-images-data
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/visp.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/visp.git
Homepage: http://visp.inria.fr

Package: libvisp-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui-dev (= ${binary:Version}),
	libvisp-io-dev (= ${binary:Version}),
	libvisp-detection-dev (= ${binary:Version}),
	libvisp-ar-dev (= ${binary:Version}),
	libvisp-blob-dev (= ${binary:Version}),
	libvisp-me-dev (= ${binary:Version}),
	libvisp-klt-dev (= ${binary:Version}),
	libvisp-sensor-dev (= ${binary:Version}),
	libvisp-robot-dev (= ${binary:Version}),
	libvisp-visual-features-dev (= ${binary:Version}),
	libvisp-vision-dev (= ${binary:Version}),
	libvisp-vs-dev (= ${binary:Version}),
	libvisp-mbt-dev (= ${binary:Version}),
	libvisp-tt-dev (= ${binary:Version}),
	libvisp-tt-mi-dev (= ${binary:Version})
Suggests: libvisp-doc
Description: development files for ViSP
 This is a metapackage providing development package necessary for
 development of ViSP (Visual Servoing Platform).
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, 
	libvisp-core3.0 (= ${binary:Version}),
	libopencv-dev,
	liblapack-dev,
	libgsl-dev,
	libxml2-dev
Replaces: libvisp-dev (<< 3.0.0-1)
Breaks: libvisp-dev (<< 3.0.0-1)
Description: development files for libvisp-core
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) core.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: visual servoing platform core library
 This package contains the ViSP (Visual Servoing Platform) core runtime
 libraries.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-core3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-core3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-core3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) core library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-gui3.0 (= ${binary:Version}),
	libx11-dev
Description: development files for libvisp-gui
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) graphical user
 interface (GUI) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform gui library
 This package contains the ViSP (Visual Servoing Platform) graphical user
 interface (GUI) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-gui3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-gui3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-gui3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) graphical user interface library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-io3.0 (= ${binary:Version}),
	libjpeg-dev,
	libpng-dev
Description: development files for libvisp-io
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) input/output
 (io) library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform io library
 This package contains the ViSP (Visual Servoing Platform) input/output
 (io) runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-io3.0-dbg
Section: debug
Architecture: any
Depends: ${misc:Depends}, libvisp-io3.0 (= ${binary:Version})
Description: Debugging symbol for libvisp-io3.0
 This package contains detached debugging symbol for ViSP 
 (Visual Servoing Platform) input/output library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-detection-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	libvisp-core-dev (= ${binary:Version}),
	libvisp-detection3.0 (= ${binary:Version}),
	libzbar-dev,
	libdmtx-dev
Description: development files for libvisp-detection
 This package contains the header files and static library needed to compile
 applications that use ViSP (Visual Servoing Platform) detection
 library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross
 platform library that allows prototyping and developing applications
 using visual tracking and visual servoing technics at the heart of the
 researches done by Inria Lagadic team. ViSP is able to compute control
 laws that can be applied to robotic systems. It provides a set of visual
 features that can be tracked using real time image processing or computer
 vision algorithms. ViSP provides also simulation capabilities. 
 .
 ViSP can be useful in robotics, computer vision, augmented reality and
 computer animation.

Package: libvisp-detection3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
	${shlibs:Depends},
	libvisp-core3.0 (= ${binary:Version})
Description: visual servoing platform detection library
 This package contains the ViSP (Visual Servoing Platform) detection
 runtime library.
 .
 ViSP standing for Visual Servoing Platform is a modular cross

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening flags.
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

# Retrieve environment information.
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Linux-specific stuff (dc1394, v4l, ois only available on linux)
ifeq ($(DEB_HOST_ARCH_OS),linux)
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=ON -DUSE_V4L2=ON -DUSE_OIS=ON
else
  CMAKE_ARCH_FLAGS = -DUSE_DC1394=OFF -DUSE_V4L2=OFF -DUSE_OIS=OFF
endif

# freenect is not available on hurd.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
  CMAKE_ARCH_FLAGS += -DUSE_LIBFREENECT=OFF
else
  CMAKE_ARCH_FLAGS += -DUSE_LIBFREENECT=ON
endif

# CMake flags
CMAKE_FLAGS = \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_INSTALL_LIBDIR="lib/$(DEB_HOST_MULTIARCH)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
	-DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_EXE_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
	-DCMAKE_BUILD_TYPE=Release \
	-DBUILD_DEMOS=ON \
	-DBUILD_TESTS=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_TUTORIALS=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DUSE_FFMPEG=OFF \
	-DUSE_OPENCV=ON \
	-DUSE_COIN3D=ON \
	-DUSE_LAPACK=ON \
	-DUSE_GSL=ON \
	-DUSE_XML2=ON \
	-DUSE_GTK2=OFF \
	-DUSE_JPEG=ON \
	-DUSE_PNG=ON \
	-DUSE_X11=ON \
	-DUSE_ZBAR=ON \
	-DUSE_DMTX=ON \
	$(CMAKE_ARCH_FLAGS)

%:
	dh $@ --buildsystem=cmake --parallel

override_dh_clean:
	dh_clean -O--buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_build-indep:
	dh_auto_build -- visp_doc # Generate Doxygen HTML documentation.

override_dh_installdocs:
	dh_installdocs -X.md5

override_dh_strip:
	dh_strip -plibvisp-core3.0 --dbg-package=libvisp-core3.0-dbg
	dh_strip -plibvisp-gui3.0 --dbg-package=libvisp-gui3.0-dbg
	dh_strip -plibvisp-io3.0 --dbg-package=libvisp-io3.0-dbg
	dh_strip -plibvisp-detection3.0 --dbg-package=libvisp-detection3.0-dbg
	dh_strip -plibvisp-ar3.0 --dbg-package=libvisp-ar3.0-dbg
	dh_strip -plibvisp-blob3.0 --dbg-package=libvisp-blob3.0-dbg
	dh_strip -plibvisp-me3.0 --dbg-package=libvisp-me3.0-dbg
	dh_strip -plibvisp-klt3.0 --dbg-package=libvisp-klt3.0-dbg
	dh_strip -plibvisp-sensor3.0 --dbg-package=libvisp-sensor3.0-dbg
	dh_strip -plibvisp-robot3.0 --dbg-package=libvisp-robot3.0-dbg
	dh_strip -plibvisp-visual-features3.0 --dbg-package=libvisp-visual-features3.0-dbg
	dh_strip -plibvisp-vision3.0 --dbg-package=libvisp-vision3.0-dbg
	dh_strip -plibvisp-vs3.0 --dbg-package=libvisp-vs3.0-dbg
	dh_strip -plibvisp-mbt3.0 --dbg-package=libvisp-mbt3.0-dbg
	dh_strip -plibvisp-tt3.0 --dbg-package=libvisp-tt3.0-dbg
	dh_strip -plibvisp-tt-mi3.0 --dbg-package=libvisp-tt-mi3.0-dbg
	dh_strip

# Parallelism is disabled in tests as some cannot run at the same
# time
#
# Due to numerical imprecision, some tests are failing on ia64.
# This is not a critical issue so we let the testing fail on this
# architecture for now.
# See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=723803
ifeq ($(DEB_HOST_ARCH),ia64)
  DH_AUTOTEST_CAN_FAIL=true
else
  DH_AUTOTEST_CAN_FAIL=false
endif

override_dh_auto_test-indep:

override_dh_auto_test-arch:
	export VISP_INPUT_IMAGE_PATH=/usr/share/visp-images-data/ \
	 && dh_auto_test --max-parallel=1 || ${DH_AUTOTEST_CAN_FAIL}

# Since Ogre removal no more useful
#override_dh_install:
#ifneq ($(DEB_HOST_ARCH_OS),hurd)
#  ifneq ($(DEB_HOST_ARCH_OS),kfreebsd)
#	# On hurd and kfreebsd usr/lib/*/visp/* is empty and produces an error
#	dh_install "usr/lib/*/visp/*" -p libvisp-dev
#        # Continue with regular dh_install
#	dh_install
#  endif
#endif

=== debian/watch ===
version=3
# Mangle upstream pre-releases to make sure they are ordered before
# the final release.
opts=dversionmangle=s/\+dfsg//,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/,\
pgpsigurlmangle=s/$/.asc/ \
http://visp.inria.fr/download \
(?:.*/|)visp-(\d\S*)\.(?:tar\.(?:gz|bz2|xz)|tgz|tbz2|txz|zip)(?:|\?\S+)
